"blerh1.wav" => string FILENAME;

fun void Blah()
{
    SndBuf blah => dac;
    me.dir() + FILENAME => blah.read;
    Math.random2f( 1.2, 2.2 ) => blah.rate;
    blah.length() / blah.rate() / 2 => now;
    blah =< dac;
}

// name: gametra.ck
// desc: gametrak boilerplate example
//
// author: Ge Wang (ge@ccrma.stanford.edu)
// date: summer 2014

// z axis deadzone
0.009 => float DEADZONE;

// which joystick
0 => int device;
// get from command line
if( me.args() ) me.arg(0) => Std.atoi => device;

// data structure for gametrak
class GameTrak
{
    // timestamps
    time lastTime;
    time currTime;
    
    // previous axis data
    float lastAxis[6];
    // current axis data
    float axis[6];
    
    // is button pressed
    false => int pressed;
}
// gametrack
GameTrak gt;

// HID objects
Hid trak;
HidMsg msg;

// open joystick 0, exit on fail
if( !trak.openJoystick( device ) ) me.exit();

// print
<<< "joystick '" + trak.name() + "' ready", "" >>>;

// spork control
spork ~ gametrak();
// print
spork ~ print();

// print
fun void print()
{
    // time loop
    while( true )
    {
        // values
        <<< "axes:", gt.axis[0],gt.axis[1],gt.axis[2], gt.axis[3],gt.axis[4],gt.axis[5] >>>;
        // advance time
        100::ms => now;
    }
}

// gametrack handling
fun void gametrak()
{
    while( true )
    {
        // wait on HidIn as event
        trak => now;
        
        // messages received
        while( trak.recv( msg ) )
        {
            // joystick axis motion
            if( msg.isAxisMotion() )
            {            
                // check which
                if( msg.which >= 0 && msg.which < 6 )
                {
                    // check if fresh
                    if( now > gt.currTime )
                    {
                        // time stamp
                        gt.currTime => gt.lastTime;
                        // set
                        now => gt.currTime;
                    }
                    // save last
                    gt.axis[msg.which] => gt.lastAxis[msg.which];
                    // the z axes map to [0,1], others map to [-1,1]
                    if( msg.which != 2 && msg.which != 5 )
                    { msg.axisPosition => gt.axis[msg.which]; }
                    else
                    {
                        1 - ((msg.axisPosition + 1) / 2) - DEADZONE => gt.axis[msg.which];
                        if( gt.axis[msg.which] < 0 ) 0 => gt.axis[msg.which];
                    }
                }
            }
            
            // joystick button down
            else if( msg.isButtonDown() )
            {
                <<< "button", msg.which, "down" >>>;
                true => gt.pressed;
                //spork ~ Blah();
            }
            
            // joystick button up
            else if( msg.isButtonUp() )
            {
                <<< "button", msg.which, "up" >>>;
                false => gt.pressed;
            }
        }
    }
}


//-----------------------------------------------------------------------------
// name: LiSa-Sndbuf2.ck
// desc: Live sampling utilities for ChucK
//
// author: Jack Atherton
//
// Combining Dan Trueman's various helper scripts for Lisa
// https://github.com/ccrma/music220a/blob/master/chuck-examples/special/LiSa-SndBuf.ck
// http://chuck.cs.princeton.edu/doc/examples/special/LiSa-munger2.ck
//-----------------------------------------------------------------------------

// PARAMS
class AhhSynth extends Chubgraph
{
    LiSa lisa => outlet;
    
    // spawn rate: how often a new grain is spawned (ms)
    25 =>  float grainSpawnRateMS;
    0 =>  float grainSpawnRateVariationMS;
    0 =>  float grainSpawnRateVariationRateMS;
    
    // position: where in the file is a grain (0 to 1)
    0.61 =>  float grainPosition;
    0.03 =>  float grainPositionRandomness;
    
    // grain length: how long is a grain (ms)
    300 =>  float grainLengthMS;
    10 =>  float grainLengthRandomnessMS;
    
    // grain rate: how quickly is the grain scanning through the file
    1.004 =>  float grainRate; // 1.002 == in-tune Ab
    0.015 =>  float grainRateRandomness;
    
    // ramp up/down: how quickly we ramp up / down
    5 =>  float rampUpMS;
    10 =>  float rampDownMS;
    
    // gain: how loud is everything overall
    1 =>  float gainMultiplier;
    
    float myFreq;
    fun float freq( float f )
    {
        f => myFreq;
        61 => Std.mtof => float baseFreq;
        myFreq / baseFreq * 0.98 => grainRate;
        
        return myFreq;
    }
    
    fun float freq()
    {
        return myFreq;
    }
    
    fun float gain( float g )
    {
        g => gainMultiplier;
        return g;
    }
    
    fun float gain()
    {
        return gainMultiplier;
    }
    
    dur bufferlen;
    
    fun void Init( string filename )
    {
        SndBuf buf; 
        me.dir() + filename => buf.read;
        buf.length() => lisa.duration;
        // copy samples in
        for( int i; i < buf.samples(); i++ )
        {
            lisa.valueAt( buf.valueAt( i ), i::samp );
        }
        
        
        buf.length() => bufferlen;
        
        // LiSa params
        100 => lisa.maxVoices;
        0.1 => lisa.gain;
        true => lisa.loop;
        false => lisa.record;
    }
    
    // modulate
    SinOsc freqmod => blackhole;
    0.1 => freqmod.freq;
    
    
    
    0.5 => float maxGain;
    
    fun void SetGain()
    {
        while( true )
        {
            maxGain * gainMultiplier => lisa.gain;
            1::ms => now;
        }
    }
    spork ~ SetGain();
    
    
    fun void SpawnGrains()
    {
        // create grains
        while( true )
        {
            // grain length
            ( grainLengthMS + Math.random2f( -grainLengthRandomnessMS / 2, grainLengthRandomnessMS / 2 ) )
            * 1::ms => dur grainLength;
            
            // grain rate
            grainRate + Math.random2f( -grainRateRandomness / 2, grainRateRandomness / 2 ) => float grainRate;
            
            // grain position
            ( grainPosition + Math.random2f( -grainPositionRandomness / 2, grainPositionRandomness / 2 ) )
            * bufferlen => dur playPos;
            
            // grain: grainlen, rampup, rampdown, rate, playPos
            spork ~ PlayGrain( grainLength, rampUpMS::ms, rampDownMS::ms, grainRate, playPos);
            
            // advance time (time per grain)
            // PARAM: GRAIN SPAWN RATE
            grainSpawnRateMS::ms  + freqmod.last() * grainSpawnRateVariationMS::ms => now;
            grainSpawnRateVariationRateMS => freqmod.freq;
        }
    }
    spork ~ SpawnGrains();
    
    // sporkee
    fun void PlayGrain( dur grainlen, dur rampup, dur rampdown, float rate, dur playPos )
    {
        lisa.getVoice() => int newvoice;
        
        if(newvoice > -1)
        {
            lisa.rate( newvoice, rate );
            lisa.playPos( newvoice, playPos );
            lisa.rampUp( newvoice, rampup );
            ( grainlen - ( rampup + rampdown ) ) => now;
            lisa.rampDown( newvoice, rampdown) ;
            rampdown => now;
        }
    }


}


//-----------------------------------------------------------------------------
// name: ks-chord.ck
// desc: karplus strong comb filter bank
//
// authors: Madeline Huberth (mhuberth@ccrma.stanford.edu)
//          Ge Wang (ge@ccrma.stanford.edu)
// date: summer 2014
//       Stanford Center @ Peking University
//-----------------------------------------------------------------------------

// single voice Karplus Strong chubgraph
class KS extends Chubgraph
{
    // sample rate
    second / samp => float SRATE;
    
    // ugens!
    DelayA delay;
    OneZero lowpass;
    
    // noise, only for internal use
    Noise n => delay;
    // silence so it doesn't play
    0 => n.gain;
    
    // the feedback
    inlet => delay => lowpass => delay => outlet;
    // max delay
    1::second => delay.max;
    // set lowpass
    -1 => lowpass.zero;
    // set feedback attenuation
    .9 => lowpass.gain;
    
    // mostly for testing
    fun void play( float pitch, dur T )
    {
        tune( pitch ) => float length;
        // turn on noise
        1 => n.gain;
        // fill delay with length samples
        length::samp => now;
        // silence
        0 => n.gain;
        // let it play
        T-length::samp => now;
    }
    
    // tune the fundamental resonance
    fun float tune( float pitch )
    {
        // computes further pitch tuning for higher pitches
        pitch - 43 => float diff;
        0 => float adjust;
        if( diff > 0 ) diff * .0125 => adjust;
        // compute length
        computeDelay( Std.mtof(pitch+adjust) ) => float length;
        // set the delay
        length::samp => delay.delay;
        //return
        return length;
    }
    
    // set feedback attenuation
    fun float feedback( float att )
    {
        // sanity check
        if( att >= 1 || att < 0 )
        {
            <<< "set feedback value between 0 and 1 (non-inclusive)" >>>;
            return lowpass.gain();
        }
        
        // set it        
        att => lowpass.gain;
        // return
        return att;
    }
    
    // compute delay from frequency
    fun float computeDelay( float freq )
    {
        // compute delay length from srate and desired freq
        return SRATE / freq;
    }
}

// chord class for KS
class KSChord extends Chubgraph
{
    // array of KS objects    
    KS chordArray[4];
    
    // connect to inlet and outlet of chubgraph
    for( int i; i < chordArray.size(); i++ ) {
        inlet => chordArray[i] => outlet;
    }
    
    // set feedback    
    fun float feedback( float att )
    {
        // sanith check
        if( att >= 1 || att < 0 )
        {
            <<< "set feedback value between 0 and 1 (non-inclusive)" >>>;
            return att;
        }
        
        // set feedback on each element
        for( int i; i < chordArray.size(); i++ )
        {
            att => chordArray[i].feedback;
        }
        
        return att;
    }
    
    // tune 4 objects
    fun float tune( float pitch1, float pitch2, float pitch3, float pitch4 )
    {
        pitch1 => chordArray[0].tune;
        pitch2 => chordArray[1].tune;
        pitch3 => chordArray[2].tune;
        pitch4 => chordArray[3].tune;
    }
}

NRev revL => dac.left;
NRev revR => dac.right;
AhhSynth ahh1 => KSChord chord1 => Pan2 pan1;
AhhSynth ahh2 => KSChord chord2 => Pan2 pan2;
pan1.left => revL;
pan1.right => revR;
pan2.left => revL;
pan2.right => revR;
-0.3 => pan1.pan;
0.3 => pan2.pan;

880 => ahh1.freq;
ahh1.Init( FILENAME );

880 => ahh2.freq;
ahh2.Init( "blerh2.wav" );

0.05 => revL.mix => revR.mix;
0.14 => revL.gain => revR.gain;

chord1.feedback( 0.9 );
chord2.feedback( 0.9 );
chord1.tune( 60, 64, 67, 71 );
chord2.tune( 61, 64, 67, 70 );

class Echo2 extends Chubgraph
{
    inlet => DelayL l => outlet;
    l => Gain g => l;
    
    fun void set( float feedback, dur echoTime )
    {
        feedback => g.gain;
        echoTime => l.max => l.delay;
    }

    set( 0.7, 0.5::second );
}

float goalEchoGain;
fun void CreateAndRunEchoes()
{
    8 => int NUMECHO;
    Echo echoes[NUMECHO];
    Pan2 panners[NUMECHO];
    Gain echoGainL, echoGainR;
    
    for( int i; i < NUMECHO; i++ )
    {
        // connect
        chord1 => echoes[i] => panners[i];
        chord2 => echoes[i];
        panners[i].left => echoGainL => revL;
        panners[i].right => echoGainR => revR;
        
        // select parameters
        // pan
        if( i % 2 ) 
        { 
            Math.random2f( -1, -0.6 ) => panners[i].pan;
        }
        else
        {
            Math.random2f( 0.6, 1 ) => panners[i].pan;
        }
        
        // echo
        //echoes[i].set( 0.8, Math.random2f( 1.6, 2.8 )::second );
        1 => echoes[i].mix;
        0.15 => echoes[i].gain;
        Math.random2f( 0.05 * (i+1), 0.2 * (i+1) )::second => echoes[i].max => echoes[i].delay;
    }
    
    
    // set volume
    0.02 => float gainSlew;
    0 => float currentGain;
    while( true )
    {
        gainSlew * ( goalEchoGain - currentGain ) +=> currentGain;
        currentGain => echoGainL.gain => echoGainR.gain;
        10::ms => now;
    }
}
spork ~ CreateAndRunEchoes();




fun void GameTrakControls()
{
    while( true )
    {

            /*
            // spawn rate: how often a new grain is spawned (ms)
    25 =>  float grainSpawnRateMS;
    0 =>  float grainSpawnRateVariationMS;
    0.0 =>  float grainSpawnRateVariationRateMS;
    
    // position: where in the file is a grain (0 to 1)
    0.61 =>  float grainPosition;
    0.2 =>  float grainPositionRandomness;
    
    // grain length: how long is a grain (ms)
    300 =>  float grainLengthMS;
    10 =>  float grainLengthRandomnessMS;
    
    // grain rate: how quickly is the grain scanning through the file
    1.004 =>  float grainRate; // 1.002 == in-tune Ab
    0.015 =>  float grainRateRandomness;
    
    // ramp up/down: how quickly we ramp up / down
    50 =>  float rampUpMS;
    200 =>  float rampDownMS;
    */
        gt.axis[2] => float h;
        Std.scalef( h, 0, 1, 0.1, 0.9 ) => ahh1.grainPosition;
        
        0.03 => float dudZone;
        if( h < 0.0 )
        {
            0 => ahh1.gain;
        }
        else if( h < dudZone )
        {
            Std.scalef( h, 0.0, dudZone, 0, 1 ) => ahh1.gain;
        }
        else
        {
            1 => ahh1.gain;
        }
        
        ( gt.axis[1] + 1 ) / 2 => float y;
        Math.pow( 1 - y, 4 ) * 475 + 25 => ahh1.grainSpawnRateMS;
        
        ( gt.axis[0] + 1 ) / 2 => float x;
        Std.scalef( x, 0, 1, 20, 100 ) => Std.mtof => ahh1.freq;
        Std.scalef( x, 0, 1, 300, 20 ) => ahh1.grainLengthMS;
        Std.scalef( x, 0, 1, 0.015, 0.3 ) => ahh1.grainRateRandomness;
        
        
        gt.axis[5] => float hh;
        Std.scalef( hh, 0, 1, 0.1, 0.55 ) => ahh2.grainPosition;
        
        if( hh < 0.0 )
        {
            0 => ahh2.gain;
        }
        else if( hh < dudZone )
        {
            Std.scalef( hh, 0.0, dudZone, 0, 1 ) => ahh2.gain;
        }
        else
        {
            1 => ahh2.gain;
        }
        
        ( gt.axis[4] + 1 ) / 2 => float yy;
        Math.pow( 1 - yy, 4 ) * 475 + 25 => ahh2.grainSpawnRateMS;
        
        ( gt.axis[3] + 1 ) / 2 => float xx;
        Std.scalef( xx, 0, 1, 20, 100 ) => Std.mtof => ahh2.freq;
        Std.scalef( xx, 0, 1, 300, 20 ) => ahh2.grainLengthMS;
        
        
        if( gt.pressed ) 
        {
            1 => goalEchoGain;
        }
        else
        {
            0 => goalEchoGain;
        }
        
        10::ms => now;
    }
}
spork ~ GameTrakControls();

//dac => WvOut2 wavOut => blackhole;
//me.dir() + "performance.wav" => wavOut.wavFilename;

external Event stopRecording;
stopRecording => now;
//wavOut.closeFile();

